/********************************** (C) COPYRIGHT *******************************
 * File Name          : peripheral.h
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2018/12/11
 * Description        :           
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for 
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/

#ifndef PERIPHERAL_H
#define PERIPHERAL_H

#ifdef __cplusplus
extern "C"
{
#endif

/*********************************************************************
 * INCLUDES
 */

/*********************************************************************
 * CONSTANTS
 */


// Simple BLE Peripheral Task Events
#define SBP_START_DEVICE_EVT                              0x0001
#define SBP_PERIODIC_EVT                                  0x0002
#define OTA_FLASH_ERASE_EVT                               0x0004	  //OTA Flash	
	
	

/*********************************************************************
 * MACROS
 */

/*********************************************************************
 * FUNCTIONS
 */

/*
 * Task Initialization for the BLE Application
 */
extern void Peripheral_Init( void );

/*
 * Task Event Processor for the BLE Application
 */
extern uint16 Peripheral_ProcessEvent( uint8 task_id, uint16 events );

extern void GotoResetVector(UINT32 entry_add);

extern uint8 ReadSafeFlag(void);

extern void DisableAllIRQ(void);

/*********************************************************************
*********************************************************************/

#ifdef __cplusplus
}
#endif

#endif 
